<?
/**
* Class UserHelper
* for User class manipulation
*/
class UserHelper {

	/**
	 * Get list of all users by manager, include manager
	 *
	 * @param unknown $user
	 * @return unknown
	 */
	function findAllUsers($user) {
		$result = array();
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
		
    	if ($user->isManager()) {
			$sel_str =  "select u.u_id, u.u_name, u.u_login, u.u_manager_id from users u, user_status_list usl
				where (u.u_manager_id = ". $user->getUserId() ." or u.u_id = ". $user->getUserId() .") and usl.usl_id = u.u_active and usl.usl_hidden = 0
				order by u.u_manager_id, u.u_name";
    	} else {
    		$sel_str =  "select u.u_id, u.u_name, u.u_login, u.u_manager_id from users u, user_status_list usl
				where (u.u_manager_id = ". $user->getManagerId() ." or u.u_id = ". $user->getManagerId() .") and usl.usl_id = u.u_active and usl.usl_hidden = 0
				order by u.u_manager_id, u.u_name";
    	}
		
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		while ($val = $rc->fetchRow()) {
      			$result[] = $val;
      		}
      		$result = mu_sort($result,"u_manager_id,u_name");
  		}
  		
  		return $result;
	}
	
	/**
	 * Find user by login
	 *
	 * @param string $login
	 * @return array
	 */
	function findUserByLogin($login) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
		$db->setFetchMode(DB_FETCHMODE_ASSOC);    		
  		$sth = $db->prepare("select u.u_id, u.u_name from users u, user_status_list usl where u.u_login = '!' and u.u_active = usl.usl_id and usl.usl_hidden = 0");
  		$data = array($login);
  		$rc = $db->execute($sth, $data);

  		if (DB::isError($rc) == 0) {
    		if ($val = $rc->fetchRow()) {
		    	return $val;
    		} else {
      			return false;
    		}
  		}
	    return false;
	}
	
	/**
	 * Find user by user ID
	 *
	 * @param string $user_id
	 * @return array
	 */
	function findUserById($user_id, $user) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    	
    	if(!isset($user)) return false;
    		
    	$sel_str = "select u.u_name, u.u_login, u.u_password, c.c_name, c.c_www, u.u_rate, c.c_currency
			from users u, user_status_list usl left join companies c on (u.u_company_id=c.c_id)
			where u.u_id=$user_id
				and u.u_active=usl.usl_id
				and (u.u_manager_id = ". $user->getUserId() ." or u.u_id = ". $user->getUserId() .")
				and usl.usl_hidden=0";
 		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();

    		if ($val["u_name"] != '') {
      			return $val;
    		} else {
      			return false;
    		}
  		}
		return false;
	}
	
	/**
	 * Get user details string
	 *
	 * @param object $user
	 * @param object $i18n
	 * @return string
	 */
	function getUserDetailsString($user, $i18n) {
	  $pers_manager_info = "";
	  
	  if ($user->isManager()) {
        $pers_manager_info = $i18n->getKey('label.pminfo');
      }
      
      if($user->getBehalfId()>0) {
      	$username = sprintf($i18n->getKey('label.pbehalf_info'), $user->getUserName(), $pers_manager_info, $user->getBehalfName());
      } else {
      	$username = sprintf("%s %s", $user->getUserName(), $pers_manager_info);
      }
      
      if ($user->getCompanyName()) {
      	$www = trim($user->getWww());
      	if ($www = trim($user->getWww())) {
      		if (substr($www,0,7) == "http://") {
      			$www = substr($www,7);
      		}
      		if (substr($www,-1)=="/") {
      			$www = substr($www,0,strlen($www)-1);
      		}
      		
        	$company_str = $user->getCompanyName()." (<a href='".$user->getWww()."' target=\"_blank\">".$www."</a>)";
      	} else {
      		$company_str = $user->getCompanyName();
      	}
      	$res = sprintf($i18n->getKey('label.pinfo'), $username, $company_str);
      } else {
        $res = sprintf($i18n->getKey('label.pinfo2'), $username);
      }
      return $res;
	}
	
	/**
	 * Create new account for user
	 *
	 * @param string $name
	 * @param string $email
	 * @param string $password
	 * @param string $company
	 * @param string $company_www
	 * @param string $currency
	 * @return boolean
	 */
	function insertAccount($name, $email, $password, $company, $company_www, $currency) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$id = $db->nextId('companies_c_id');
  		
		$sth = $db->prepare("insert into companies (c_id, c_name, c_www, c_currency) values ($id, '!', '!', '!')");
		$data = array($company, $company_www, $currency);
		$rc = $db->execute($sth, $data);

  		if (DB::isError($rc) == 0) {
			$password = str_replace("'","\'",$password);
  			$password = str_replace("!","\!",$password);
  			$password = str_replace("?","\?",$password);
  			$password = str_replace("&","\&",$password);

    		$sth = $db->prepare("insert into users (u_name, u_login, u_password, u_company_id) values ('!', '!', '".addslashes($password)."', $id)");
    		$data = array($name, $email);
    		$rc = $db->execute($sth, $data);
    		if (DB::isError($rc) == 0) {
    			return true;
    		} else {
      			$sth = $db->prepare("delete from companies where c_id = $id");
      			$rc = $db->execute($sth);
			    return false;
    		}
  		}
    	return false;
	}
	
	/**
	 * I don't know
	 *
	 * @return unknown
	 */
	function getHiddenUser() {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sth = $db->prepare("select usl_id from user_status_list where usl_hidden = 1");
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
    		if ($val[0]) {
      			return $val[0];
    		} else {
      			return false;
    		}
		}
	    return false;
	}
	
	function updateAccount($user, $name, $email, $password, $company, $company_www, $currency) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

    	$hidden_ppl = UserHelper::getHiddenUser();
		$pass_part = '';
		$upd_str2 = '';
		if ($password) {
			$password = str_replace("'","\'",$password);
  			$password = str_replace("!","\!",$password);
  			$password = str_replace("?","\?",$password);
  			$password = str_replace("&","\&",$password);

			$pass_part = ", u_password = '!'";
		}
  		if ($currency) {
    		$curr_part = ", c_currency = '$currency'";
  		}
  		if ($hidden_ppl) {
    		$upd_str = "update users set u_name = '!', u_login = '!' $pass_part where u_id = ".$user->getUserId()." and u_active <> $hidden_ppl";
    		//if (!$user_manager_id) {
      		//$upd_str = "update users set u_name = '!', u_login = '!' $pass_part where u_id = $user_id and u_active <> $hidden_ppl";
      		
      		// update company information
      		if ($user->isManager()) {
      			$sel_str = "select u_company_id from users where u_id = ".$user->getUserId();
      				      	$sth = $db->prepare($sel_str);
		      	$rc = $db->execute($sth);
		      	if (DB::isError($rc) == 0) {
		        	$val = $rc->fetchRow();
		        	if ($val[0]) {
		          		$upd_str2 = "update companies set c_name = '!', c_www = '!' $curr_part where c_id = $val[0]";
		          		$sth = $db->prepare($upd_str2);
		          		$data = array($company, $company_www);
		          		$rc = $db->execute($sth, $data);
		          		if (DB::isError($rc) != 0) {
				            return false;
		          		}
		        	} else return false;
		        } else return false;
      		}
	        
	    	$sth = $db->prepare($upd_str);
	    	$data = array($name, $email);
	    	if ($password) {
	      		$data = array($name, $email, $password);
	    	}
	    	$rc = $db->execute($sth, $data);
	    	if (DB::isError($rc) == 0) {
	      		return true;
	    	} else {
				return false;
	    	}
  		}
  		return false;
	}
	
	/**
	 * Append new employee
	 *
	 * @param string $manager_id
	 * @param string $name
	 * @param string $email
	 * @param string $password
	 * @param float $rate
	 * @return bool
	 */
	function addEmployee($user, $name, $email, $password, $rate=0) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    	
    	$rate = str_replace(",",".",$rate);	
  		if ($rate=='') $rate = 0;
		
  		$password = str_replace("'","\'",$password);
		$password = str_replace("!","\!",$password);
		$password = str_replace("?","\?",$password);
		$password = str_replace("&","\&",$password);

  		$sth = $db->prepare("insert into users (u_name, u_login, u_password, u_manager_id, u_company_id, u_rate)
        	values ('!', '!', '!', ".$user->getUserId().", ".$user->getCompanyId().", $rate)");
  		$data = array($name, $email, $password);
  		$rc = $db->execute($sth, $data);
  		if (DB::isError($rc) == 0) {
    		return true;
  		}
	    return false;
	}
	
	function updateEmployee($user, $user_id, $name, $email, $password, $rate=0) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
		$rate = str_replace(",",".",$rate);	
  		if ($rate=='') $rate = 0;
  		
  		$hidden_ppl = UserHelper::getHiddenUser();
  		$pass_part = '';
  		if ($password) {
			$password = str_replace("'","\'",$password);
  			$password = str_replace("!","\!",$password);
  			$password = str_replace("?","\?",$password);
  			$password = str_replace("&","\&",$password);
    		$pass_part = ", u_password = '".addslashes($password)."'";
  		}
  		if ($hidden_ppl) {
    		//$sel_str = "update users set u_name = '!', u_login = '!', u_rate=$rate $pass_part where u_id = $user_id and u_manager_id = $user_manager_id and u_active <> $hidden_ppl";
    		//if ($user_manager_id == $user_id) {
      			$sel_str = "update users set u_name = '!', u_login = '!', u_rate=$rate $pass_part where u_id = $user_id and u_active <> $hidden_ppl 
      			 and (u_manager_id = ". $user->getUserId() ." or u_id = ". $user->getUserId() .")";
    		//}
	    	$data = array($name, $email);
	    	$sth = $db->prepare($sel_str);
	    	$rc = $db->execute($sth, $data);
	    	if (DB::isError($rc) == 0) {
	      		return true;
	    	}
	  	}
		return false;
	}
	
	/**
	 * Deleting employee record
	 *
	 * @param unknown $user_id
	 * @param unknown $user_manager_id
	 * @return unknown
	 */
	function deleteEmployee($user, $user_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

		$employee_count = UserHelper::getEmployeeCount($user_id);
		$hidden_user = UserHelper::getHiddenUser();
		
  		if (($user->getUserId() == $user_id) && $employee_count>0)     // Deleting a manager
  			return false;
  		
    	if (!$employee_count) {  //  No workers

    		import('ProjectHelper');
	  		$hidden_pr = ProjectHelper::getHiddenProject();
	  		if ($hidden_pr) {
	    		$sth = $db->prepare("update projects set p_status = $hidden_pr where p_manager_id = $user_id");
	    		$rc = $db->execute($sth);
	    		if (!DB::isError($rc) == 0) {
		          return false;
	    		}
	  		}
	  		
	  		import('ActivityHelper');
	  		$hidden_act = ActivityHelper::getHiddenActivity();
	  		if ($hidden_pr) {
	    		$sth = $db->prepare("update activities set a_status = $hidden_act where a_manager_id = $user_id");
	    		$rc = $db->execute($sth);
	    		if (!DB::isError($rc) == 0) {
		          return false;
	    		}
	  		}
    	}
		
		$sth = $db->prepare("update users set u_active = $hidden_user where u_id = $user_id
				and (u_manager_id = ". $user->getUserId() ." or u_id = ". $user->getUserId() .")");
  		$rc = $db->execute($sth);
  		if (!DB::isError($rc) == 0) {
		    return false;
  		} else {
    		return true;
  		}
	}

	/**
	 * Get employee count for manager
	 *
	 * @param unknown $manager_id
	 * @return unknown
	 */
	function getEmployeeCount($manager_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
	  	$sth = $db->prepare("select count(u.u_id) from users u, user_status_list usl where u.u_manager_id = $manager_id and usl.usl_id = u.u_active and usl.usl_hidden = 0");
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
    		return $val[0];
  		}
    	return false;
  	}
	
  	
  	/**
  	 * Temporary function
  	 *
  	 * @param unknown $login
  	 * @return unknown
  	 */
  	function getPassword($login) {
  		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$sth = $db->prepare("select u.u_password from users u, user_status_list usl where u.u_login = '!' and u.u_active = usl.usl_id and usl.usl_hidden = 0");
  		$data = array($login);
  		$rc = $db->execute($sth, $data);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
	
	    	if ($val[0] != '') {
	      		return $val[0];
	    	} else {
	      		return false;
	    	}
  		}
	    return false;
	}
}
?>