<?

import('form.FormElement');
	
class Calendar extends FormElement {
		
		var $mLocation		= "";
		var $mHolidays		= array();
		var $mShowHolidays	= true;
		var $mMarkedDays	= array();
		var $mStartWeek		= 1;
		var $mDateFormat	= "d/m/Y";
		var $mSysDateFormat	= "d/m/Y"; // use for build URI parameters
		var $lToday			= "Today";
		
		var $mCommonCell    = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid White; color: #333333; background : #D9D9D9; background-color : #D9D9D9; font: 8pt;";
		var $mDayCell       = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid Silver; color: #333333; background : #ffffff; background-color : #ffffff; font: 8pt;";
		var $mDayCellActive = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid Silver; color: #666666; background : #A6CCF7; background-color : #A6CCF7; font: 8pt;";
        var $mDayCellWE     = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid Silver; color: #666666; background : #f7f7f7; background-color : #f7f7f7; font: 8pt;";
        var $mDayCellHolyday= "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid Silver; color: #666666; background : #f7f7f7; background-color : #f7f7f7; font: 8pt;";
        var $mDayCellMark   = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid White; color: #666666; background : #EEEEEE; background-color : #EEEEEE; font: 8pt;";
        var $mDayHeaderCell = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid White; color: #333333; font: 8pt;";
        var $mDayHeaderCellWE = "padding-bottom : 5px; padding-left : 5px; padding-right : 5px; padding-top : 5px; padding : 5px 5px 5px 5px; border : 1px solid White; color: #999999; font: 8pt;";

		var $mName          = "";
		var $mAllDays       = true;
		var $cClassName		= "Calendar";
		
		function Calendar($name) {
		    $this->mName = $name;
		    $this->mMonthNames = array('January','February','March','April','May','June','July','August','September','October','November','December');
		    $this->mWeekDayNameChort= array("Sn","Mo","Tw","Th","Td","Fr","St");
		}
		
		function setLocalization($i18n) {
			FormElement::setLocalization($i18n);
			$this->mMonthNames		= $i18n->cMonthNames;
			$this->mWeekDayNameChort= $i18n->cWeekDayShortNames;
			if (is_array($i18n->cHolidays)) {
				foreach ($i18n->cHolidays as $fday) {
					$date_a = split("/",$fday); // input format d/m
					$this->mHolidays[] = mktime(0,0,0, $date_a[1], $date_a[0], date("Y")) + 7200;
				}
			}
			$this->mStartWeek		= $i18n->cStartWeek;
			if ($i18n->getKey('label.today'))
				$this->lToday		= $i18n->getKey('label.today');
			$this->mDateFormat		= $i18n->getDateFormat();
		}
		
		function setStyle($style) { $this->mStyle = $style; }
		function setCellStyle($style) { $this->mCellStyle = $style; }
		function setACellStyle($style) { $this->mACellStyle = $style; }
		function setLinkStyle($style) { $this->mLinkStyle = $style; }
		function setDateFormat($format) { $this->mDateFormat = $format;}
		function setSysDateFormat($format) { $this->mSysDateFormat = $format;}
		
		function setShowHolidays($value) {
			$this->mShowHolidays	= $value;
		}
		
		function setMarkedDays($list) {
		    if (is_array($list) && count($list)>0) $this->mAllDays = false;
			foreach ($list as $day) {
				$this->mMarkedDays[$day["date"]] = $day["url"];
			}
		}

		/**
		 * @return void
		 * @param date
		 * @desc Enter description here...
		 */
		function toString($date="") {
			$indate = $this->mValue;
			if (!$indate) $indate = date($this->mSysDateFormat);;
		
			if (!$this->isRenderable()) return "";
			
			//current year and month
			if ( strlen ( $indate ) > 0 ) {
				$ch_s = split("[.,/ ]",$this->mSysDateFormat);
				$ch_s = array_flip($ch_s);
				$v_s = split("[.,/ ]",$indate);
	  			$thisyear = $v_s[$ch_s["Y"]];
	  			$thismonth = $v_s[$ch_s["m"]];
			} else {
	  			$thismonth = date("m");
	  			$thisyear = date("Y");
			}
			
			// next date, month, year
			$next = mktime ( 2, 0, 0, $thismonth + 1, 1, $thisyear );
			$nextyear = date ( "Y", $next );
			$nextmonth = date ( "m", $next );
			$nextdate = date ( $this->mSysDateFormat, $next );
	
			// prev date, month, year
			$prev = mktime ( 2, 0, 0, $thismonth - 1, 1, $thisyear );
			$prevyear = date ( "Y", $prev );
			$prevmonth = date ( "m", $prev );
			$prevdate = date ( $this->mSysDateFormat, $prev );
			
			$str = $this->_genStyles();
			
			$str .= '<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr><td align="center"><div class="CalendarCommonCell">'.
			        //'<a href="?date='.$prevyear.'">&lt;&lt;</a> '.
			        '<a href="?date='.$prevdate.'">&lt;&lt;&lt;</a>  '.
			        $this->mMonthNames[$thismonth-1].'&nbsp;'.$thisyear.
			        '  <a href="?date='.$nextdate.'">&gt;&gt;&gt;</a>'.
			        //' <a href="?date='.$nextyear.'">&gt;&gt;</a>'.
			        '</div></td></tr>
					</table>';
			
			$str .= '<center>
					<table border="0" cellpadding="1" cellspacing="1" width="100%">
					<tr>';
			
			$str .= "<tr>";
			
			for ( $i=0; $i<7; $i++ ) {
				if ($this->mStartWeek == 0) {
					if ($i==0 || $i==6) {
						$str .= '<td class="CalendarDayHeaderCellWE">'.$this->mWeekDayNameChort[$i].'</td>';
					} else {
						$str .= '<td class="CalendarDayHeaderCell">'.$this->mWeekDayNameChort[$i].'</td>';
					}
				} else {
					if ($i==5 || $i==6) {
						$str .= '<td class="CalendarDayHeaderCellWE">'.$this->mWeekDayNameChort[$i].'</td>';
					} else {
						$str .= '<td class="CalendarDayHeaderCell">'.$this->mWeekDayNameChort[$i].'</td>';
					}
				}
			}
				
			$str .= "</tr>\n";
			
			if ( $this->mStartWeek == 1 )
  				list($wkstart,$monthstart,$monthend,$start_date) = $this->_getMondayBefore( $thisyear, $thismonth );
			else {
				list($wkstart,$monthstart,$monthend,$start_date) = $this->_getSundayBefore( $thisyear, $thismonth );
			}

			for ( $i = $wkstart; $i<=$monthend;  $i=mktime(0,0,0,$thismonth,$start_date+=7,$thisyear) ) {
				$str .= "<TR>\n";
  				for ( $j = 0; $j < 7; $j++ ) {
  					$date = mktime(0,0,0,$thismonth,$start_date+$j,$thisyear);
    				if ( $date >= $monthstart && $date <= $monthend ) {
    					
    					$stl_cell = "";
    					$stl_link = "";
    					
    					// weeekend
    					if ( $this->mStartWeek == 1 ) {
	  						if ($j==6 || $j==5) { $stl_cell = ' class="CalendarDayCellWE"'; $stl_link = ' class="CalendarLinkWE"';} 
	  						   else { $stl_cell = ' class="CalendarDayCell"'; }
    					} else {
    						if ($j==0 || $j==6) { $stl_cell = ' class="CalendarDayCellWE"'; $stl_link = ' class="CalendarLinkWE"'; }
    						   else { $stl_cell = ' class="CalendarDayCell"'; }
    					}
    					
    					// holidays
    					if ($this->mShowHolidays)
    					foreach ($this->mHolidays as $day) {
    						if ( $day == $date)	{
    							$stl_cell = ' class="CalendarDayHolyday"';
    							$stl_link = ' class="CalendarLinkHolyday"';
    						}
    					}

    					// selected day
    					if ( $indate == date($this->mSysDateFormat,$date)) $stl_cell = ' class="CalendarDayCellActive"';
    					
    					
    					$str .= '<td'.$stl_cell.'>';
    					
    					if ($this->mAllDays) {
    					    $str .= "<a".$stl_link." href=\"?".$this->mName."=".date($this->mSysDateFormat,$date)."\">".date("d",$date)."</a>";
    					} elseif ($this->mMarkedDays[ date($this->mSysDateFormat,$date) ] ) {
    							$stl_link = ' class="CalendarDayMark"';
      							$str .= "<a".$stl_link." href=\"".$this->mMarkedDays[date($this->mSysDateFormat,$date)]."\">".date("d",$date)."</a>";
      						} else {
      							$str .= date("d",$date);
      						}
      						
	  					$str .= "</TD>";
    				} else {
      					$str .= "<TD>&nbsp;</TD>\n";
    				}
  				}
  				$str .= "</TR>\n";
			}
			
			$str .= "<tr><td colspan=\"7\" align=\"center\"><a href=\"?".$this->mName."=".date($this->mSysDateFormat)."\">".$this->lToday."</a> (".date($this->mDateFormat).")</td></tr>\n";
			
			$str .= "</table>";
			$str .= "<input type=\"hidden\" name=\"$this->mName\" value=\"$indate\">\n";
			return $str;
		}
		
		function toStringControl() {
		    return $this->toString();
		}
		
		function _getSundayBefore($year,$month) {
 			$weekday = date ( "w", mktime ( 2, 0, 0, $month, 1, $year ) );
  			return array(
  				mktime ( 0, 0, 0, $month, 1 - $weekday, $year ),
  				mktime ( 0, 0, 0, $month, 1, $year ),
				mktime ( 0, 0, 0, $month + 1, 0, $year ),
				(1 - $weekday)
  			);
		}
		
		function _getMondayBefore($year,$month) {
  			$weekday = date ( "w", mktime ( -2, 0, 0, $month, 1, $year ) );
  			return array(
  				mktime ( 0, 0, 0, $month, 1 - $weekday, $year ),
  				mktime ( 0, 0, 0, $month, 1, $year ),
				mktime ( 0, 0, 0, $month + 1, 0, $year ),
				(1 - $weekday)
  			);
		}

		function _genStyles() {
		    $str = "<style>\n";
		    $str .= ".CalendarCommonCell {". $this->mCommonCell  ."}\n";
		    $str .= ".CalendarDayCell {". $this->mDayCell  ."}\n";
		    $str .= ".CalendarDayCellActive {". $this->mDayCellActive  ."}\n";
		    $str .= ".CalendarDayCellWE {". $this->mDayCellWE  ."}\n";
		    $str .= ".CalendarDayHolyday {". $this->mDayCellHolyday  ."}\n";
		    $str .= ".CalendarDayMark {". $this->mDayCellMark  ."}\n";
		    $str .= ".CalendarDayHeaderCell {". $this->mDayHeaderCell  ."}\n";
		    $str .= ".CalendarDayHeaderCellWE {". $this->mDayHeaderCellWE  ."}\n";
		    $str .= ".CalendarLinkWE { color: #999999;}\n";
		    $str .= ".CalendarLinkHolyday {color: #999999;}\n";
		    $str .= "</style>\n";
		    return $str;
		}
}
?>