<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');
	import('ActivityHelper');
	import('ProjectHelper');

	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}
	
	$cl_activity_id = (int)$request->getParameter('act_id');
	if ($cl_activity_id>0) {
		$_SESSION["cl_activity_id"] = $cl_activity_id;
	}
	if ($cl_activity_id==0) {
		$cl_activity_id = $_SESSION["cl_activity_id"];
	}
	
	$ud = ActivityHelper::findActivityById($user->getUserId(), $cl_activity_id);
	if ($request->getMethod()=="POST") {
		$cl_name  = $request->getParameter('name');
		$cl_name  = trim($cl_name);
		$cl_project_id = $request->getParameter("project");
	} else {
        $cl_name	= @$ud["a_name"];
        $cl_project_id = @$ud["a_project_id"];
	}
	
	$form = new Form('activityForm');
	$form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"name","value"=>@$cl_name));
	$project_list = ProjectHelper::findAllProjects($user);
	$form->addInput(array("type"=>"combobox",
    	"onchange"=>"fillActivity();",
    	"name"=>"project",
    	"value"=>@$cl_project_id,
    	"data"=>$project_list,
    	"datakeys"=>array("p_id","p_name"),
    	"empty"=>array(""=>$i18n->getKey('controls.project_bind'))
    	));
    $form->addInput(array("type"=>"hidden","name"=>"act_id","value"=>@$cl_activity_id));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit","value"=>$i18n->getKey('button.save')));
	
	if ($request->getMethod()=="POST") {
		import('form.check.Validator');
		
		$validator = new Validator($cl_name);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid()) {
			$errors->add("name",$i18n->getKey("errors.wrong"),$i18n->getKey("form.activity.name"));	
		}
		
		if ($errors->isEmpty()) {
			$ulo = ProjectHelper::findProjectByName($user->getUserId(), $cl_name);
			if (($ulo && $cl_activity_id==$ulo["a_id"]) || (!$ulo)) {
				if (ActivityHelper::update($user->getUserId(), $cl_activity_id, $cl_name, $cl_project_id)) {
					Header("Location: activities.php");
					exit();
				} else
					$errors->add("editact",$i18n->getKey("errors.activity_update"));
			} else 
				$errors->add("exact",$i18n->getKey("errors.activity_exist"));
		}			
	} // post
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
    $smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad=\"document.activityForm.name.focus()\"");
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("title_page",$i18n->getKey("form.activity.edit_str"));
  	if ($ud) {
    	$smarty->assign("content_page_name","activity_edit.tpl");
    } else {
    	$smarty->assign("content_page_name","syserror.tpl");
    }
  	$smarty->display(INDEX_TEMPLATE);
?>