<?php

// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');
	import('TimeHelper');
	import('DateTime');
	
	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}

    $date_ask	= $request->getParameter('date');
    $cl_ts		= $request->getParameter('ts');
    if (!$date_ask) die("Not exists date parameter");
    $crdate = new DateTime(SYS_DATEFORMAT);
	$crdate->parseVal($date_ask);
	
	if ($request->getMethod()=="POST") {
	    $cl_start		= $request->getParameter('start');
	    $cl_finish		= $request->getParameter('finish');
	    $cl_duration	= $request->getParameter('duration');
	    $cl_note		= $request->getParameter('note');
	    $cl_project		= $request->getParameter('project');
	    $cl_activity	= $request->getParameter('activity');
	    $in_behalf_id	= $request->getParameter('behalfUser');
	} else {
		if ($ud = TimeHelper::findTimeByUserAndDate($user->getActiveUser(),$cl_ts,$crdate->toString(DB_DATEFORMAT))) {
			$cl_project = $ud["al_project_id"];
	        $cl_activity = $ud["al_activity_id"];
	        $cl_start = $ud["tfrom"];
	        $cl_finish = $ud["tto"];
	        $cl_duration = $ud["tdur"];
	        $cl_note = $ud["al_comment"];	
		}
	}
	if (!isset($in_behalf_id)) $in_behalf_id = $user->getBehalfId();
    
	// elements of form 'mytimeForm'
	import('ProjectHelper');
	$project_list = ProjectHelper::findAllProjects($user);	
	$form = new Form('mytimeForm');
    $form->addInput(array("type"=>"combobox",
    	"onchange"=>"fillActivityDir();",
    	"name"=>"project",
    	"style"=>"width: 250",
    	"value"=>$cl_project,
    	"data"=>$project_list,
    	"datakeys"=>array("p_id","p_name"),
    	"empty"=>array(""=>$i18n->getKey('controls.select.project'))
    	));

    import('ActivityHelper');
 	$activity_list = ActivityHelper::findAllActivity($user);
    $form->addInput(array("type"=>"combobox",
    	"name"=>"activity",
    	"style"=>"width: 250",
    	"value"=>$cl_activity,
    	"data"=>$activity_list,
    	"datakeys"=>array("a_id","a_name"),
    	"empty"=>array(""=>$i18n->getKey('controls.select.activity'))
    	));
    $form->addInput(array("type"=>"text","name"=>"start","value"=>$cl_start,"onchange"=>"formDisable('start');"));
    $form->addInput(array("type"=>"text","name"=>"finish","value"=>$cl_finish,"onchange"=>"formDisable('finish');"));
    $form->addInput(array("type"=>"text","name"=>"duration","value"=>$cl_duration,"onchange"=>"formDisable('duration');"));
    $form->addInput(array("type"=>"textarea","name"=>"note","style"=>"width: 250","value"=>$cl_note));
    $form->addInput(array("type"=>"hidden","name"=>"date","value"=>$date_ask));
    $form->addInput(array("type"=>"hidden","name"=>"ts","value"=>$cl_ts));
	$form->addInput(array("type"=>"submit","name"=>"btmytime","value"=>$i18n->getKey('button.save')));

	if ($request->getMethod()=="POST") {
		// check input data
		if (!$cl_project || $cl_project<=0) {
			$errors->add("project",$i18n->getKey("errors.wr_project"));
		}
		if (!$cl_activity || $cl_activity<=0) {
			$errors->add("activity",$i18n->getKey("errors.wr_activity"));
		}
		if (!$cl_duration) {
        	if ($cl_start || $cl_finish) {
            	if (!TimeHelper::isValidTime($cl_start)) {
              		$errors->add("start",$i18n->getKey("errors.wrong"),$i18n->getKey("form.mytime.start"));
            	}
            	if (!TimeHelper::isValidTime($cl_finish)) {
              		$errors->add("finish",$i18n->getKey("errors.wrong"),$i18n->getKey("form.mytime.finish"));
            	}
            	if (!TimeHelper::isCorrectTimeInterval($cl_start, $cl_finish)) {
    				$errors->add("interval",$i18n->getKey("errors.wr_interval"));
    			}
        	} else {
        		$errors->add("start",$i18n->getKey("errors.empty"),$i18n->getKey("form.mytime.start"));
        		$errors->add("finish",$i18n->getKey("errors.empty"),$i18n->getKey("form.mytime.finish"));
        		$errors->add("duration",$i18n->getKey("errors.empty"),$i18n->getKey("form.mytime.duration"));
        	}
    	} else {
       		if (!TimeHelper::isValidDuration($cl_duration)) {
       			$errors->add("duration",$i18n->getKey("errors.wrong"),$i18n->getKey("form.mytime.duration"));
       		}
    	}
    	// finish check input data

    	if (ProjectHelper::isProjectExists($cl_project) &&
			ActivityHelper::isActivityExists($cl_activity) &&
			$errors->isEmpty()) {
				TimeHelper::update($crdate->toString(DB_DATEFORMAT), $cl_ts, $user->getActiveUser(), $cl_project, $cl_activity, $cl_start, $cl_finish, $cl_duration, $cl_note);
				header("Location: mytime.php");
			}
		
	}
	
  	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
  	$smarty->assign("curr_date", $crdate->toString() );
	$smarty->assign("project_list", $project_list );
	$smarty->assign("activity_list", $activity_list );
    $smarty->assign("forms",array($form->getName()=>$form->toArray()) );
    $smarty->assign("timestring",TimeHelper::parseTimeString($crdate));
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("onload","onLoad = \"document.mytimeForm.project.focus();fillActivityDir();\"");
    $smarty->assign("title_page",$i18n->getKey("form.mytime.edit_title"));
    if ($ud) {
    	$smarty->assign("content_page_name","mytime_edit.tpl");
    } else {
    	$smarty->assign("content_page_name","syserror.tpl");
    }
  	$smarty->display(INDEX_TEMPLATE);
?>