<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');
	import('ProjectHelper');

	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}
	
	if ($request->getMethod()=="POST") {
		$cl_name  = $request->getParameter('name');
		$cl_name  = trim($cl_name);
	}
	
	$form = new Form('projectForm');
	$form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"name","value"=>@$cl_name));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit","value"=>$i18n->getKey('button.add')));
	
	if ($request->getMethod()=="POST") {
		import('form.check.Validator');
		
		$validator = new Validator($cl_name);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid()) {
			$errors->add("name",$i18n->getKey("errors.wrong"),$i18n->getKey("form.project.name"));	
		}
		
		if ($errors->isEmpty()) {
			if (!ProjectHelper::findProjectByName($user->getUserId(), $cl_name)) {
				if (ProjectHelper::insert($user->getUserId(), $cl_name)) {
					Header("Location: projects.php");
					exit();
				} else
					$errors->add("editproj",$i18n->getKey("errors.project_add"));
			} else 
				$errors->add("editproj",$i18n->getKey("errors.project_exist"));
		}			
	} // post
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
    $smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad=\"document.projectForm.name.focus()\"");
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("title_page",$i18n->getKey("form.project.add_str"));
  	$smarty->assign("content_page_name","project_add.tpl");
  	$smarty->display(INDEX_TEMPLATE);
?>